-- simple_logic_tb.vhd
--
-- test bench for simple_logic

library ieee;
use ieee.std_logic_1164.all;

entity simple_logic_tb is
end simple_logic_tb;

architecture sim of simple_logic_tb is
  component simple_logic
    port
    (
      in_1 : in std_logic;
      in_2 : in std_logic;
      out_and : out std_logic;
      out_or : out std_logic
    );
  end component;
  
  signal in_1_sim : std_logic;
  signal in_2_sim : std_logic;
  signal out_and_sim : std_logic;
  signal out_or_sim : std_logic;

begin
  dut : simple_logic
  port map
  (
    in_1 => in_1_sim,
    in_2 => in_2_sim,
    out_and => out_and_sim,
    out_or => out_or_sim
  );
  
  process
  begin
    in_1_sim <= '0';
    in_2_sim <= '0';
    
    wait for 50 ns;
    in_1_sim <= '1';
    in_2_sim <= '0';
    
    wait for 50 ns;
    in_1_sim <= '0';
    in_2_sim <= '1';
    
    wait for 50 ns;
    in_1_sim <= '1';
    in_2_sim <= '1';
    
    wait;
  end process;
    
end sim;