library ieee;
use ieee.std_logic_1164.all;

entity bincntr_tb is
end bincntr_tb;

architecture sim of bincntr_tb is
component bincntr is
  port
  (
    clk : in  std_logic;
    counter : out std_logic_vector(1 downto 0)
  );
end component;

signal clk_sim : std_logic;
signal counter_sim : std_logic_vector(1 downto 0);

constant clk_period : time := 1ms;

begin
  dut : bincntr
  port map
  (
    clk => clk_sim,
    counter => counter_sim
  );
  
  clk_gen : process
  begin
    clk_sim <= '1';
    wait for clk_period/2;
    clk_sim <= '0';
    wait for clk_period/2;
  end process clk_gen;

  sim_proc : process
  begin
    wait for 10ms;
    wait;
  end process sim_proc;
end sim;
