-- FPGAs fuer Maker
-- Cord Elias

-- dff_tb.vhd
--
-- test bench for d-flip-flop

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity dff_tb is
end dff_tb;

architecture sim of dff_tb is
component dff is
  port
  (
    clk : in std_logic; -- clock input
    d : in std_logic; -- data input
    q : out std_logic  -- data output
  );
end component;

signal clk_sim : std_logic;
signal d_sim : std_logic;
signal q_sim : std_logic;

constant clk_period : time := 400ns;
begin
 dut : dff
 port map
 (
   clk => clk_sim,
   d => d_sim,
   q => q_sim
 );
 
 process
 begin
   clk_sim <= '1';
   wait for clk_period/2;
   clk_sim <= '0';
   wait for clk_period/2;
 end process;
 
 process
 begin
  d_sim <= '0';
  wait for clk_period*1.1;
  d_sim <= '1';
  wait for clk_period * 2.5;
  d_sim <= '0';
  wait for clk_period * 2.3;
  d_sim <= '1';
  wait for clk_period * 0.2;
  d_sim <= '0';
  
  wait;
 end process;

end sim;

