library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity cntr_mod is
  port
  (
    clk : in std_logic;
    cntr_out : out std_logic_vector(1 downto 0)
  );
end cntr_mod;

architecture impl of cntr_mod is
signal cntr_reg : unsigned(1 downto 0) := "00";
signal cntr_next : unsigned(1 downto 0);
begin
  -- register update
  process (clk)
  begin
    if rising_edge(clk) then
      cntr_reg <= cntr_next;
    end if;
  end process;
  -- next logic
  cntr_next <= "00" when (cntr_reg = "10") else cntr_reg + 1;
  -- out logic
  cntr_out <= std_logic_vector(cntr_reg);
end impl;
