-- shiftreg_rot.vhd
library ieee;
use ieee.std_logic_1164.all;

entity shiftreg_rot is
  port
  (
    clk : in std_logic;
    ls : in std_logic;
    load : in std_logic_vector(3 downto 0);
    reg_out : out std_logic_vector(3 downto 0)
  );
end shiftreg_rot;

architecture impl of shiftreg_rot is
signal shift_reg : std_logic_vector(3 downto 0) := "0000";
signal shift_next : std_logic_vector(3 downto 0);
begin
  -- register update
  process (clk)
  begin
    if rising_edge(clk) then
      shift_reg <= shift_next;
    end if;
  end process;
  -- next logic
  shift_next <= shift_reg(2 downto 0) & shift_reg(3)
                when ls = '0' else load;
  -- out logic
  reg_out <= shift_reg;
end impl;
