-- shiftreg_rot_tb.vhd
library ieee;
use ieee.std_logic_1164.all;

entity shiftreg_rot_tb is
end shiftreg_rot_tb;


architecture sim of shiftreg_rot_tb is
component shiftreg_rot is
  port
  (
    clk : in std_logic;
    ls : in std_logic;
    load : in std_logic_vector(3 downto 0);
    reg_out : out std_logic_vector(3 downto 0)
  );
end component;

signal clk_sim : std_logic;
signal ls_sim : std_logic := '0';
signal load_sim : std_logic_vector(3 downto 0) := "0000";
signal reg_out_sim : std_logic_vector(3 downto 0);

constant clkp : time := 10ns;

begin

  dut : shiftreg_rot
  port map
  (
    clk => clk_sim,
    ls => ls_sim,
    load => load_sim,
    reg_out => reg_out_sim
  );

  process
  begin
    clk_sim <= '1';
    wait for clkp/2;
    clk_sim <= '0';
    wait for clkp/2;
  end process;

  process
  begin
    wait for clkp*2;
    load_sim <= "0100";
    wait for clkp*1;
    ls_sim <= '1';
    wait for clkp*1;
    ls_sim <= '0';
    wait for clkp*2;
    load_sim <= "1001";
    wait for clkp*8;
    ls_sim <= '1';
    wait for clkp*1;
    ls_sim <= '0';
    
    wait;
  end process;
end sim;
