-- shiftreg_simple.vhd
library ieee;
use ieee.std_logic_1164.all;

entity shiftreg_simple is
  port
  (
    clk : in std_logic;
    reset : in std_logic;
    sh_in : in std_logic;
    sh_out : out std_logic
  );
end shiftreg_simple;

architecture impl of shiftreg_simple is
signal shift_reg : std_logic_vector(3 downto 0) := "0000";
signal shift_next : std_logic_vector(3 downto 0);
begin
  -- register update
  process (clk)
  begin
    if rising_edge(clk) then
      if reset = '1' then
        shift_reg <= "0000";
      else
        shift_reg <= shift_next;
      end if;
    end if;
  end process;
  -- next logic
  shift_next <= shift_reg(2 downto 0) & sh_in;
  -- out logic
  sh_out <= shift_reg(3);
end impl;
