-- shiftreg_simple_tb.vhd
library ieee;
use ieee.std_logic_1164.all;

entity shiftreg_simple_tb is
end shiftreg_simple_tb;


architecture sim of shiftreg_simple_tb is
component shiftreg_simple is
  port
  (
    clk : in std_logic;
    reset : in std_logic;
    sh_in : in std_logic;
    sh_out : out std_logic
  );
end component;

signal clk_sim : std_logic;
signal reset_sim : std_logic := '0';
signal sh_in_sim : std_logic := '0';
signal sh_out_sim : std_logic;

constant clkp : time := 10ns;

begin

  dut : shiftreg_simple
  port map
  (
    clk => clk_sim,
    reset => reset_sim,
    sh_in => sh_in_sim,
    sh_out => sh_out_sim
  );

  process
  begin
    clk_sim <= '1';
    wait for clkp/2;
    clk_sim <= '0';
    wait for clkp/2;
  end process;

  process
  begin
    reset_sim <= '1';
    wait for clkp*2;
    reset_sim <= '0';
    wait for clkp*1;
    sh_in_sim <= '1';
    wait for clkp*1;
    sh_in_sim <= '0';
    wait for clkp*8;
    sh_in_sim <= '1';
    wait for clkp*2;
    sh_in_sim <= '0';
    
    wait;
  end process;
end sim;
