-- clockenable_good.vhd

library ieee;
use ieee.std_logic_1164.all;

entity clockenable_good is
  port
  (
    clk : in std_logic;
    en : in std_logic;
    data_in : in std_logic;
    data_out : out std_logic
  ); 
end clockenable_good;

architecture impl of clockenable_good is
signal data_reg : std_logic;
signal data_next : std_logic;
signal en_reg : std_logic;
signal en_next : std_logic;
begin
  process (clk)
  begin
    if rising_edge(clk) then
      en_reg <= en_next;
    end if;
  end process;
  en_next <= en;
  
  process (clk)
  begin
    if rising_edge(clk) and en_reg = '1' then
      data_reg <= data_next;
    end if;
  end process;
  data_next <= data_in;
  data_out <= data_reg;
end impl;
