-- bin6tobcd_tb.vhd

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity bin6tobcd_tb is
end bin6tobcd_tb;

architecture sim of bin6tobcd_tb is
component bin6tobcd is
  port
  (
    bin6 : in std_logic_vector(5 downto 0);
    ones : out std_logic_vector(3 downto 0);
    tens : out std_logic_vector(2 downto 0)
  );
end component;

signal bin6_sim : std_logic_vector(5 downto 0);
signal ones_sim : std_logic_vector(3 downto 0);
signal tens_sim : std_logic_vector(2 downto 0);

constant clkp : time := 200ns;
begin

  dut : bin6tobcd
  port map
  (
    bin6 => bin6_sim,
    ones => ones_sim,
    tens => tens_sim
  );

  process
  begin
    for k in 0 to 63 loop
      bin6_sim <= std_logic_vector(to_unsigned(k,6));
      wait for clkp;
    end loop;
   wait;
  end process;
end sim;
