-- pwm.vhd

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity pwm is
  port
  (
    clk : in std_logic;
    dc : in std_logic_vector(5 downto 0); -- duty cycle
    pwm : out std_logic
  );
end pwm;

architecture impl of pwm is
signal pwm_reg : std_logic := '0';
signal pwm_next : std_logic;

signal cntr_reg : unsigned(7 downto 0) := X"00";
signal cntr_next : unsigned(7 downto 0);

begin
  process (clk)
  begin
    if rising_edge(clk) then
      pwm_reg <= pwm_next;
      cntr_reg <= cntr_next;
    end if;
  end process;
  
  cntr_next <= cntr_reg + 1;
  pwm_next <= '1' when ((cntr_reg(7) = '0') and (cntr_reg(6 downto 1) < unsigned(dc))) else '0';
  pwm <= pwm_reg;
end impl;
