-- pwm_tb.vhd

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity pwm_tb is
end pwm_tb;

architecture sim of pwm_tb is
component pwm is
  port
  (
    clk : in std_logic;
    dc : in std_logic_vector(5 downto 0); -- duty cylce
    pwm : out std_logic
  );
end component;

signal clk_sim : std_logic;
signal dc_sim : std_logic_vector(5 downto 0);
signal pwm_sim : std_logic;

constant clkp : time := 10ns;

begin

  dut : pwm
  port map
  (
    clk => clk_sim,
    dc => dc_sim,
    pwm => pwm_sim
  );

  process
  begin
    clk_sim <= '1';
    wait for clkp/2;
    clk_sim <= '0';
    wait for clkp/2;
  end process;
  
  process
  begin
    for dc in 0 to 63 loop
      dc_sim <= std_logic_vector(to_unsigned(dc,6));
      wait for clkp*256;
    end loop;
    wait;
  end process;

end sim;
