-- rgbm_test1.vhd

library ieee;
use ieee.std_logic_1164.all;


entity rgbm_test1 is
  port
  (
    clk100 : in std_logic;
    btnC : in std_logic;
    sw : in std_logic_vector(9 downto 0);
    r0 : out std_logic;
    r1 : out std_logic;
    g0 : out std_logic;
    g1 : out std_logic;
    b0 : out std_logic;
    b1 : out std_logic;
    a : out std_logic;
    b : out std_logic;
    c : out std_logic;
    d : out std_logic;
    clk_pix : out std_logic;
    stb : out std_logic;
    oe_n : out std_logic
  );
end rgbm_test1;

architecture impl of rgbm_test1 is
signal clk5 : std_logic;
signal reset : std_logic;
signal oe : std_logic;

component clk_wiz_0
  port
  (
    clk_in1 : in std_logic;
    clk_out1 : out std_logic
  ); 
end component;


component rgbm_cntr is
  generic
  (
    row_count : integer := 32;
    rows_per_frame : integer := 2;
    col_count : integer := 32;
    rsize : integer := 6;
    stb_len : integer := 2 -- length of stb pulse in pix_clk cycles
  );
  port
  (
    clk_sys : in std_logic;
    reset : in std_logic;
    oe_len : in std_logic_vector(rsize-1 downto 0);
    led_x : out std_logic_vector(rsize-1 downto 0);
    led_y : out std_logic_vector(rsize-1 downto 0);
    pix_clk : out std_logic;
    pix_clk_g : out std_logic;
    stb : out std_logic;
    oe : out std_logic
  );
end component;


begin

  clk_mgnt : clk_wiz_0
  port map
  (
    clk_in1 => clk100,
    clk_out1 => clk5
  ); 

  matrix_cntrl : rgbm_cntr
   port map
  (
    clk_sys => clk5,
    reset => reset,
    oe_len => (0|1|2 => '1', others => '0'),
    led_x => open,
    led_y => open,
    pix_clk => open,
    pix_clk_g => clk_pix,
    stb => stb,
    oe => oe
  );
    
  oe_n <= not oe;
  reset <= btnC;
  
  a <= sw(0);
  b <= sw(1);
  c <= sw(2);
  d <= sw(3);
  
  r0 <= sw(9);
  g0 <= sw(8);
  b0 <= sw(7);
  
  r1 <= sw(6);
  g1 <= sw(5);
  b1 <= sw(4);
  
end impl;
