-- FPGAs fuer Maker
--
-- Cord Elias
--
-- fpga_basic.vhd
--
-- simple demo with concurrent and sequential VHDL statements

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity fpga_basic is
  port
  (
    clk : in std_logic; -- clock input
    in_1 : in std_logic; -- switch /pushbutton input
    in_2 : in std_logic;  -- switch /pushbutton input
    blink_o : out std_logic; -- output for alternating signal ( ~ 1Hz)
    and_o : out std_logic;  -- output for and operation
    or_o : out std_logic  -- output for or operation
  );
end fpga_basic;

architecture impl of fpga_basic is
signal cntr : unsigned(24 downto 0); -- counter 

begin

-- concurrent part
  and_o <= in_1 and in_2;
  or_o <= in_1 or in_2;

-- sequential part
  cnt_proc : process (clk)
  begin
    if rising_edge(clk) then
      cntr <= cntr + 1;
    end if;
  end process cnt_proc;
  blink_o <= cntr(24);
end impl;
