library ieee;
use ieee.std_logic_1164.all;

entity de0_nano_fb is
	port
	(
		clk50 : in std_logic;
		dipsw0_n : in std_logic;
		dipsw1_n : in std_logic;
		led0 : out std_logic;
		led1 : out std_logic;
		led2 : out std_logic
	);
end de0_nano_fb;

architecture impl of de0_nano_fb is
-- all logic consistently as positive logic
-- switches on board use negative logic and
-- leds are driven on anodes
signal dipsw0 : std_logic;
signal dipsw1 : std_logic;

component fpga_basic is
	port
	(
		clk : in std_logic; -- clock input
    in_1 : in std_logic; -- switch /pushbutton input
    in_2 : in std_logic;  -- switch /pushbutton input
		blink_o : out std_logic; -- output for alternating signal ( ~ 1Hz)
		and_o : out std_logic;  -- output for and operation
    or_o : out std_logic  -- output for or operation
  );
end component;

begin
  -- inversion operations
	dipsw0 <= not dipsw0_n;
	dipsw1 <= not dipsw1_n;

	fb : fpga_basic
	port map
	(
		clk => clk50,
		in_1 => dipsw0,
		in_2 => dipsw1,
		blink_o => led0,
		and_o => led1,
		or_o => led2
	);
end impl;
