-- aglnkit_fb.vhd

library ieee;
use ieee.std_logic_1164.all;

entity aglnkit_fb is
	port
	(
		clk20 : in std_logic;
		dipsw0_n : in std_logic;
		dipsw1_n : in std_logic;
		led0_n : out std_logic;
		led1_n : out std_logic;
		led2_n : out std_logic
	);
end aglnkit_fb;

architecture impl of aglnkit_fb is
-- all logic consistently as positive logic
-- switches on board use negative logic and
-- leds are driven on cathodes
signal dipsw0 : std_logic;
signal dipsw1 : std_logic;
signal led_buf : std_logic_vector(2 downto 0);

component fpga_basic is
	port
	(
      clk : in std_logic; -- clock input
      in_1 : in std_logic; -- switch /pushbutton input
      in_2 : in std_logic;  -- switch /pushbutton input
      blink_o : out std_logic; -- output for alternating signal ( ~ 1Hz)
      and_o : out std_logic;  -- output for and operation
      or_o : out std_logic  -- output for or operation
  );
end component;



begin
  -- inversion operations
	dipsw0 <= not dipsw0_n;
	dipsw1 <= not dipsw1_n;

	fb : fpga_basic
	port map
	(
		clk => clk20,
		in_1 => dipsw0,
		in_2 => dipsw1,
		blink_o => led_buf(0),
		and_o => led_buf(1),
		or_o => led_buf(2)
	);

  led0_n <= not led_buf(0);
  led1_n <= not led_buf(1);
  led2_n <= not led_buf(2);
end impl;
