-- papilio_fb.vhd

library ieee;
use ieee.std_logic_1164.all;

entity papilio_fb is
  port
  (
    clk32 : in std_logic;
    sw0 : in std_logic;
    sw1 : in std_logic;
    led0 : out std_logic;
    led1 : out std_logic;
    led2 : out std_logic
  );
end papilio_fb;

architecture impl of papilio_fb is
-- all logic consistently as positive logic
-- switches on board use positive logic and
-- leds are driven on anodes

component fpga_basic is
  port
  (
    clk : in std_logic; -- clock input
    in_1 : in std_logic; -- switch /pushbutton input
    in_2 : in std_logic;  -- switch /pushbutton input
    blink_o : out std_logic; -- output for alternating signal ( ~ 1Hz)
    and_o : out std_logic;  -- output for and operation
    or_o : out std_logic  -- output for or operation
  );
end component;

begin
	fb : fpga_basic
	port map
	(
		clk => clk32,
		in_1 => sw0,
		in_2 => sw1,
		blink_o => led0,
		and_o => led1,
		or_o => led2
	);
end impl;